<?php
/**
*
* @package hjw video Extension
* @copyright (c) 2019 hjw
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/

namespace hjw\video\event;

/**
* @ignore
*/
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
* Event listener
*/
class main_listener implements EventSubscriberInterface
{
	static public function getSubscribedEvents()
	{
		return array(
			'core.viewtopic_modify_post_row'						=> 'video',
		);
	}

	public function video($event)
	{
		$poster = $event['post_row'];

		$div = explode ('<div class="inline-attachment">', $poster['MESSAGE']);
		$poster['MESSAGE'] = $div[0];
		$i=1;
		while ($i<count($div))
		{
			$divname = explode ('(',strip_tags($div[$i]));
			if (substr(trim($divname[0]),-4) === '.mp3')
			{
				$div[$i] = preg_replace('/"file"/', '"audio"', $div[$i]);
				$div[$i] = preg_replace('/<img src=".\/images\/upload_icons\/mp3.gif" alt="" \/>/', '', $div[$i]);
				$div[$i] = preg_replace('/<img src=".\/images\/upload_icons\/mpg.gif" alt="" \/>/', '', $div[$i]);
				$div[$i] = preg_replace('/<img src=".\/images\/upload_icons\/mov.gif" alt="" \/>/', '', $div[$i]);
				$div[$i] = preg_replace('/<a class="postlink" href/', '<audio controls=""><source src', $div[$i]);
				$div[$i] = preg_replace('/>' . trim($divname[0]) . '/', ' type="audio/mp3"></audio>', $div[$i]);
				$div[$i] = preg_replace('/<\/a>/', '', $div[$i]);
				$divx=explode('<dd>',$div[$i]);
				$divy=explode(')',$divx[1]);
				$divz=explode('</dd>',$divy[1]);
				$div[$i] = preg_replace('/' . $divz[0] . '/', '', $div[$i]);
			}
			if (substr(trim($divname[0]),-4) === '.mp4')
			{
				$div[$i] = preg_replace('/"file"/', '"video"', $div[$i]);
				$div[$i] = preg_replace('/<img src=".\/images\/upload_icons\/mpg.gif" alt="" \/>/', '', $div[$i]);
				$div[$i] = preg_replace('/<img src=".\/images\/upload_icons\/mov.gif" alt="" \/>/', '', $div[$i]);
				$div[$i] = preg_replace('/<a class="postlink" href/', '<video controls=""><source src', $div[$i]);
				$div[$i] = preg_replace('/>' . trim($divname[0]) . '/', ' type="video/mp4"></video>', $div[$i]);
				$div[$i] = preg_replace('/<\/a>/', '', $div[$i]);
				$divx=explode('<dd>',$div[$i]);
				$divy=explode(')',$divx[1]);
				$divz=explode('</dd>',$divy[1]);
				$div[$i] = preg_replace('/' . $divz[0] . '/', '', $div[$i]);
			}
			$poster['MESSAGE'] .= '<div class="inline-attachment">' . $div[$i];
			$i++;
		}
		$event['post_row'] = $poster;
	}
}
